# http://docs.dfrobot.com.cn/bxy/4.2.14ObloqMqttPublish.html
from microbit import *
import Obloq

SERVER = "iot.dfrobot.com.cn"
PORT = "1883"
SSID = "kylin"
PASSWORD = ""
IOT_ID = ""
IOT_PWD = ""
IOT_TOPIC_FUNC = ""
IOT_TOPIC_LOG = ""


def show_wait():
    image1 = Image("00000:"
                   "00000:"
                   "00000:"
                   "50000:"
                   "50000")
    image2 = Image("00000:"
                   "00000:"
                   "07000:"
                   "57000:"
                   "57000")
    image3 = Image("00000:"
                   "00900:"
                   "07900:"
                   "57900:"
                   "57900")
    display.show(image1)
    sleep(200)
    display.show(image2)
    sleep(200)
    display.show(image3)
    sleep(200)


def connect_wifi():
    while Obloq.connectWifi(SSID, PASSWORD, 10000) is not True:
        show_wait()
    display.show('Wifi')

def event(e, param):
    # display.show(str(e))
    if e == "MqttConneted":  # MQTT连接成功
        display.scroll("MQTT")
        Obloq.subscribe(IOT_TOPIC_FUNC)
        Obloq.subscribe(IOT_TOPIC_LOG)

    if e == IOT_TOPIC_FUNC:  # 收到了订阅的topic的信息
        pass
        #  display.scroll(param)
        display.show('T1')
        if param == 'L1ON':
            pin16.write_digital(1)
        elif param == 'L1OFF':
            pin16.write_digital(0)

    if e == IOT_TOPIC_LOG:
        # display.show('LL')
        if param == 'CT':  # 查询温度消息
            Obloq.publish(IOT_TOPIC_LOG, '正在收集温度...')
            avg_temp = capture_temp(10)
            Obloq.publish(IOT_TOPIC_FUNC, '%.1f' % avg_temp)
            Obloq.publish(IOT_TOPIC_LOG, '温度收集完成.')
            if avg_temp>25:
              pin16.write_digital(1)

    if e == "SubOk":  # 订阅成功
        display.show("SO")


def capture_temp(num):
    s = 0
    for i in range(1, num+1):
        s = s + temperature()
        Obloq.publish(IOT_TOPIC_LOG, '第%d次采集...' % i)
        display.show(str(i))
        sleep(1500)
    return s//10


def start_init():
    pin16.write_digital(0)
    uart.init(baudrate=9600, bits=8, parity=None, stop=1, tx=pin2, rx=pin1)
    connect_wifi()


start_init()
# 初始化MQTT的配置
Obloq.mqttConfig(event, SERVER, PORT)

# 连接MQTT
Obloq.connectMqtt(IOT_ID, IOT_PWD)
while True:
    pass


